#!/usr/bin/perl

use File::Copy;
$flen=16384*3+512;
$tlen=$flen*32;

print "\n##############################################################################################\n";
print "#                                                                                            #\n";
print "#  AX82 file system installer V0.35                                                          #\n";
print "#                                                                                            #\n";
print "#  (c) 2012-2014 Joerg Wolfram                                                               #\n";
print "#                                                                                            #\n";
print "##############################################################################################\n";

for($i=0;$i<512;$i++)
{
	$thead[$i]=chr(255);
}

$thead[0]='A';
$thead[1]='X';
$thead[2]='8';
$thead[3]='2';
$thead[4]='-';
$thead[5]='I';
$thead[6]='M';
$thead[7]='A';
$thead[8]='G';
$thead[9]='E';
$thead[10]=chr(0xaa);

$tapes=16;
if ($ARGV[0] > 0)
{
	$tapes=$ARGV[0];
}
print $tapes." tapes\n";

$ilen=$tlen*$tapes;
$thead[11]=chr($tapes-1);

print "Installing file system structure, this will take a while...\n";

open(BWRITE,">ax82_img.bin");
binmode(BWRITE);
for($i=0;$i<512;$i++)
{
	print BWRITE $thead[$i];
}

for($tape=0;$tape<$tapes;$tape++)
{
	for($j=0;$j<32;$j++)
	{
		for($i=0;$i<12;$i++)
		{
			print BWRITE chr(32);
		}
		for($i=0;$i<($flen-12);$i++)
		{
			print BWRITE chr(255);
		}
	}
}
close(BWRITE);


$ok=mkdir("TAPES_AX82",0777);

for($tape=0;$tape<$tapes;$tape++)
{
	$dname=sprintf("TAPES_AX82/TAPE_%03d",$tape);
	$ok=mkdir($dname,0777);
}

